<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <div>
            <h2>#{messages['net.ihe.gazelle.proxy.SecuredChannelConfiguration']}</h2>
            <h:form id="createForm">

                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                    <ui:define name="panel_title">#{messages['net.ihe.gazelle.proxy.SecurityParameters']}</ui:define>

                    <s:decorate template="../layout/_form_field_horizontal_pickList.xhtml">
                        <ui:param name="id" value="protocolsInput"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Protocols']}</ui:define>
                        <rich:pickList id="protocolsInput"
                                       value="#{securedChannelConfiguration.protocolTypesEnabled}"
                                       minListHeight="120px"
                                       maxListHeight="200px"
                                       disabled="#{!applicationConfigurationManager.isUserAllowedAsAdmin()}"
                                       required="true">
                            <f:selectItems
                                    value="#{securedChannelConfiguration.getAvailableProtocolsAsSelectItems()}"/>
                        </rich:pickList>
                    </s:decorate>

                    <s:decorate template="../layout/_form_field_horizontal_pickList.xhtml">
                        <ui:param name="id" value="cipherSuitesInput"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.proxy.CipherSuites']}</ui:define>
                        <rich:pickList id="cipherSuitesInput"
                                       value="#{securedChannelConfiguration.cipherSuiteTypesEnabled}"
                                       minListHeight="120px"
                                       maxListHeight="200px"
                                       required="true"
                                       disabled="#{!applicationConfigurationManager.isUserAllowedAsAdmin()}">
                            <f:selectItems
                                    value="#{securedChannelConfiguration.getAvailableCipherSuitesAsSelectItems()}"/>
                        </rich:pickList>
                    </s:decorate>


                    <s:div rendered="#{!securedChannelConfiguration.isValidKeyStore()}">
                        <s:decorate template="../layout/_form_field_horizontal_pickList.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Keystore']}</ui:define>
                            <h:outputText required="true" value="#{messages['net.ihe.gazelle.proxy.TheKeystoreIsNotLoadedCorrectly']}"
                                          style="color: red; font-weight: bold;"/>
                        </s:decorate>
                    </s:div>

                    <s:div rendered="#{securedChannelConfiguration.isValidKeyStore()}">
                        <s:decorate template="../layout/_form_field_horizontal_2.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Keystore']}</ui:define>
                            <h:selectOneRadio id="keystoreInput" required="true"
                                              value="#{securedChannelConfiguration.keyStoreLoadingMethod}">
                                <f:selectItems
                                        value="#{securedChannelConfiguration.getAvailableKeyStoreLoadingMethod()}"/>
                            </h:selectOneRadio>
                        </s:decorate>

                        <s:decorate template="../layout/_form_field_horizontal_2.xhtml">
                            <ui:param name="id" value="proxyCertificate"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.ProxyCertificateSubject']}
                            </ui:define>
                            <rich:dataTable id="subjectTable"
                                            value="#{securedChannelConfiguration.getKeyStoreSubjects()}"
                                            var="subject" rows="1" render="datascroller">
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.CommonName']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.commonName}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.OrganizationalUnit']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.organizationalUnit}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.Organization']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.organization}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.Locality']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.locality}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.StateOrProvinceName']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.stateOrProvinceName}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.CountryName']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.countryName}"/>
                                </g:column>
                            </rich:dataTable>
                        </s:decorate>
                    </s:div>


                    <s:div rendered="#{!securedChannelConfiguration.isValidTrustStore()}">
                        <s:decorate template="../layout/_form_field_horizontal_pickList.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Truststore']}</ui:define>
                            <h:outputText required="true" value="#{messages['net.ihe.gazelle.proxy.TheTruststoreIsNotLoadedCorrectly']}"
                                          style="color: red; font-weight: bold;"/>
                        </s:decorate>
                    </s:div>


                    <s:div rendered="#{securedChannelConfiguration.isValidTrustStore()}">
                        <s:decorate template="../layout/_form_field_horizontal_2.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Truststore']}</ui:define>
                            <h:selectOneRadio id="truststoreInput" required="true"
                                              value="#{securedChannelConfiguration.trustStoreLoadingMethod}">
                                <f:selectItems
                                        value="#{securedChannelConfiguration.getAvailableTrustStoreLoadingMethod()}"/>
                            </h:selectOneRadio>
                        </s:decorate>

                        <s:decorate template="../layout/_form_field_horizontal_2.xhtml">
                            <ui:param name="id" value="trustedSubjects"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.TrustedCertificatesSubjects']}
                            </ui:define>
                            <rich:dataTable id="subjectTable"
                                            value="#{securedChannelConfiguration.getTrustStoreSubjects()}"
                                            var="subject" rows="10"
                                            render="datascroller">
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.CommonName']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.commonName}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.OrganizationalUnit']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.organizationalUnit}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.Organization']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.organization}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.Locality']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.locality}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.StateOrProvinceName']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.stateOrProvinceName}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.CountryName']}"/>
                                    </ui:define>
                                    <h:outputText value="#{subject.countryName}"/>
                                </g:column>
                                <f:facet name="footer">
                                    <div class="row">
                                        <div class="#{hideRowsSelect ? 'col-lg-12 gzl-text-centered':'col-lg-6 col-lg-offset-3 gzl-text-centered'}">
                                            <rich:dataScroller renderIfSinglePage="false" immediate="true"
                                                               fastControls="hide"
                                                               styleClass="dataScroller#{dataScrollerId}"
                                                               id="#{dataScrollerId != null ? dataScrollerId : 'ds'}">
                                            </rich:dataScroller>
                                        </div>
                                    </div>
                                </f:facet>
                            </rich:dataTable>
                        </s:decorate>

                    </s:div>

                    <s:decorate template="../layout/_form_field_horizontal_2.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.proxy.EnableMutualAuthentication']}
                        </ui:define>
                        <h:selectBooleanCheckbox
                                disabled="#{!applicationConfigurationManager.isUserAllowedAsAdmin()}"
                                value="#{securedChannelConfiguration.mutualAuthentication}"/>
                    </s:decorate>

                    <!--                    </div>-->

                    <ui:define name="panel_footer">
                        <a4j:commandButton onclick="window.history.back();"
                                           styleClass="gzl-btn-red"
                                           value="#{messages['net.ihe.gazelle.proxy.Cancel']}"
                                           render="createForm"/>
                        <a4j:commandButton action="#{securedChannelConfiguration.save()}"
                                           disabled="#{!(securedChannelConfiguration.isValidTrustStore() and securedChannelConfiguration.isValidKeyStore() and applicationConfigurationManager.isUserAllowedAsAdmin())}"
                                           styleClass="gzl-btn-green"
                                           value="#{messages['net.ihe.gazelle.proxy.Save']}"
                                           render="createForm"/>
                    </ui:define>
                </ui:decorate>

            </h:form>
        </div>
    </ui:define>
</ui:composition>
